'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var History = function History(_ref) {
  var step = _ref.step;
  var length = _ref.length;
  var children = _ref.children;


  var backButton = void 0;
  var fwdButton = void 0;
  var childNodes = [];

  _react2.default.Children.forEach(children, function (child) {
    var ifEmpty = child.props['data-ifEmpty'];
    var action = child.props.action;
    if (action === "back") {

      backButton = _react2.default.createElement('button', _extends({
        disabled: step === 0 && ifEmpty === "disable",
        style: { display: step === 0 && ifEmpty === "hide" ? 'none' : 'inherit' }
      }, child.props));
      childNodes.push(backButton);
    } else if (action === "forward") {
      fwdButton = _react2.default.createElement('button', _extends({
        disabled: step === length && ifEmpty === "disable",
        style: { display: step === length && ifEmpty === "hide" ? 'none' : 'inherit' }
      }, child.props));
      childNodes.push(fwdButton);
    } else {
      childNodes.push(child);
    }
  });

  return _react2.default.createElement(
    'span',
    null,
    childNodes.map(function (childNode, index) {
      return _react2.default.createElement(
        'span',
        { key: index },
        childNode
      );
    })
  );
};

exports.default = History;