'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Handle = function () {
  function Handle(context) {
    var _this = this;

    _classCallCheck(this, Handle);

    this.ctx = context;
    this.render = function (ctx) {
      ctx.fillStyle = 'rgba(255, 255, 255, 0.6)';
      ctx.fillRect(_this.x - 3, _this.y - 3, 6, 6);
    };
    this.isHover = function (x, y) {
      var xx = _this.x;
      var yy = _this.y;
      return x > xx - 6 && x < xx + 6 && y > yy - 3 && y < yy + 3;
    };
  }

  _createClass(Handle, [{
    key: 'coords',
    set: function set(xy) {
      this.x = xy[0];
      this.y = xy[1];
    },
    get: function get() {
      return {
        x: this.x,
        y: this.y
      };
    }
  }]);

  return Handle;
}();

var CropBox = exports.CropBox = function () {
  function CropBox(args) {
    var _this2 = this;

    _classCallCheck(this, CropBox);

    this.x = args.x || 0;
    this.y = args.y || 0;
    this.width = 50;
    this.height = 50;
    this.dragging = false;
    this.canvas = args.canvas;
    this.ctx = args.ctx;

    this.selectionHandles = [];

    for (var i = 0; i < 8; i++) {
      var rect = new Handle(this.ctx);
      this.selectionHandles.push(rect);
    }

    this.isInDraggableArea = function (x, y) {
      return x > _this2.x + 3 && x < _this2.x - 3 + _this2.width && y > _this2.y + 3 && y < _this2.height + _this2.y - 3;
    };
    this.isInResizeArea = function (x, y) {
      var result = -1;
      _this2.selectionHandles.forEach(function (handle, j) {
        if (handle.isHover(x, y)) {
          result = j;
        }
      });
      return result;
    };
    this.canvas.addEventListener('mousedown', function (e) {

      var pointer = e;
      var mx = pointer.offsetX;
      var my = pointer.offsetY;

      if (!_this2.hasFocus) {
        _this2.dragX = mx - _this2.x;
        _this2.dragY = my - _this2.y;
        _this2.x = mx;
        _this2.y = my;
      }

      if (_this2.isInDraggableArea(mx, my)) {
        if (_this2.hasFocus) {
          _this2.dragX = mx - _this2.x;
          _this2.dragY = my - _this2.y;
          _this2.dragging = true;
        }
      } else {
        _this2.dragging = false;
        _this2.expectResize = _this2.isInResizeArea(mx, my);
        if (_this2.expectResize > -1 && _this2.hasFocus) {
          _this2.resizing = true;
        }
      }

      _this2.hasFocus = true;
    }, true);

    this.canvas.addEventListener('mousemove', function (e) {
      var pointer = e;
      var mx = pointer.offsetX;
      var my = pointer.offsetY;

      if (_this2.dragging) {
        _this2.canvas.style.cursor = 'move';

        var tx = mx - _this2.dragX;
        var ty = my - _this2.dragY;
        var maxX = _this2.canvas.width - _this2.width;
        var maxY = _this2.canvas.height - _this2.height;

        _this2.x = tx < 0 ? 0 : tx > maxX ? maxX : tx;
        _this2.y = ty < 0 ? 0 : ty > maxY ? maxY : ty;
      } else if (_this2.resizing) {
        var oldx = _this2.x;
        var oldy = _this2.y;

        var cursors = ['nwse-resize', 'ns-resize', 'nesw-resize', 'ew-resize', 'nwse-resize', 'ns-resize', 'nesw-resize', 'ew-resize'];

        switch (_this2.expectResize) {
          case 0:
            _this2.x = mx;
            _this2.y = my;
            _this2.width += oldx - mx;
            _this2.height += oldy - my;
            break;
          case 1:
            _this2.y = my;
            _this2.height += oldy - my;
            break;
          case 2:
            _this2.y = my;
            _this2.width = mx - oldx;
            _this2.height += oldy - my;
            break;
          case 7:
            _this2.x = mx;
            _this2.width += oldx - mx;
            break;
          case 3:
            _this2.width = mx - oldx;
            break;
          case 6:
            _this2.x = mx;
            _this2.width += oldx - mx;
            _this2.height = my - oldy;
            break;
          case 5:
            _this2.height = my - oldy;
            break;
          case 4:
            _this2.width = mx - oldx;
            _this2.height = my - oldy;
            break;
        }
        // 0 1 2
        // 7   3
        // 6 5 4
        if (_this2.width < 0) {
          _this2.width = 0;
          if (_this2.expectResize === 2) {
            _this2.expectResize = 0;
          } else if (_this2.expectResize === 0) {
            _this2.expectResize = 2;
          } else if (_this2.expectResize === 3) {
            _this2.expectResize = 7;
          } else if (_this2.expectResize === 7) {
            _this2.expectResize = 3;
          } else if (_this2.expectResize === 4) {
            _this2.expectResize = 6;
          } else if (_this2.expectResize === 6) {
            _this2.expectResize = 4;
          }
        } else if (_this2.height < 0) {
          _this2.height = 0;
          if (_this2.expectResize === 0) {
            _this2.expectResize = 6;
          } else if (_this2.expectResize === 6) {
            _this2.expectResize = 0;
          } else if (_this2.expectResize === 1) {
            _this2.expectResize = 5;
          } else if (_this2.expectResize === 5) {
            _this2.expectResize = 1;
          } else if (_this2.expectResize === 2) {
            _this2.expectResize = 4;
          } else if (_this2.expectResize === 4) {
            _this2.expectResize = 2;
          }
        }
        _this2.canvas.style.cursor = cursors[_this2.expectResize];
        if (_this2.width < 0 || _this2.height < 0) {
          console.log(_this2.width, _this2.height);
        }
      } else if (_this2.isInDraggableArea(mx, my)) {
        _this2.canvas.style.cursor = 'move';
      } else {
        _this2.canvas.style.cursor = 'crosshair';
        _this2.selectionHandles.forEach(function (handle, j) {

          var cursors = ['nwse-resize', 'ns-resize', 'nesw-resize', 'ew-resize', 'nwse-resize', 'ns-resize', 'nesw-resize', 'ew-resize'];
          if (handle.isHover(mx, my)) {
            _this2.canvas.style.cursor = cursors[j];
          }
        });
      }
    }, true);

    this.canvas.addEventListener('mouseup', function () {
      _this2.dragging = false;
      _this2.resizing = false;
      _this2.expectResize = false;
    }, true);

    this.render = this.render.bind(this);
    this.getWidth = this.getWidth.bind(this);
    this.getHeight = this.getHeight.bind(this);
    this.getLeft = this.getLeft.bind(this);
    this.getTop = this.getTop.bind(this);
    this.setWidth = this.setWidth.bind(this);
    this.setHeight = this.setHeight.bind(this);
    this.setLeft = this.setLeft.bind(this);
    this.setTop = this.setTop.bind(this);

    this.remove = function () {
      _this2.canvas.removeEventListener('mouseup');
      _this2.canvas.removeEventListener('mousedown');
      _this2.canvas.removeEventListener('mousemove');
    };
  }

  _createClass(CropBox, [{
    key: 'getWidth',
    value: function getWidth() {
      return this.width;
    }
  }, {
    key: 'getHeight',
    value: function getHeight() {
      return this.height;
    }
  }, {
    key: 'getScaleX',
    value: function getScaleX() {
      return this.scaleX;
    }
  }, {
    key: 'getScaleY',
    value: function getScaleY() {
      return this.scaleY;
    }
  }, {
    key: 'getLeft',
    value: function getLeft() {
      return this.x;
    }
  }, {
    key: 'getTop',
    value: function getTop() {
      return this.y;
    }
  }, {
    key: 'setWidth',
    value: function setWidth(value) {
      this.lastWidth = Object.assign({}, this.width);
      this.width = value;
    }
  }, {
    key: 'setHeight',
    value: function setHeight(value) {
      this.lastHeight = Object.assign({}, this.height);
      this.height = value;
    }
  }, {
    key: 'setLeft',
    value: function setLeft(value) {
      this.lastLeft = Object.assign({}, this.x);
      this.x = value;
    }
  }, {
    key: 'setTop',
    value: function setTop(value) {
      this.lastTop = Object.assign({}, this.y);
      this.y = value;
    }
  }, {
    key: 'setScaleX',
    value: function setScaleX(value) {
      this.lastScaleX = Object.assign({}, this.scaleX);
      this.scaleX = value;
    }
  }, {
    key: 'setScaleY',
    value: function setScaleY(value) {
      this.lastScaleY = Object.assign({}, this.scaleY);
      this.scaleY = value;
    }
  }, {
    key: 'render',
    value: function render() {
      var flipX = this.flipX ? -1 : 1;
      var flipY = this.flipY ? -1 : 1;
      var scaleX = flipX / this.scaleX;
      var scaleY = flipY / this.scaleY;

      if (this.hasFocus) {
        var ctx = this.ctx;
        var dashWidth = 7;

        ctx.scale(scaleX, scaleY);
        // Overlay rendering
        ctx.fillStyle = 'rgba(0, 0, 0, 0.5)';

        // ctx.fillRect(0, 0, ctx.canvas.width, ctx.canvas.height);
        this.renderOverlay(ctx);

        // Set dashed borders
        if (ctx.setLineDash !== undefined) {
          ctx.setLineDash([dashWidth, dashWidth]);
        } else if (ctx.mozDash !== undefined) {
          ctx.mozDash = [dashWidth, dashWidth];
        }

        // First lines rendering with black
        ctx.strokeStyle = 'rgba(0, 0, 0, 0.2)';
        // this.ctx.strokeRect(this.x, this.y, this.width, this.height);
        this.renderBorders(ctx);
        this.renderGrid(ctx);

        // Re render lines in white
        ctx.lineDashOffset = dashWidth;
        ctx.strokeStyle = 'rgba(255, 255, 255, 0.4)';
        // this.ctx.strokeRect(this.x, this.y, this.width, this.height);
        this.renderBorders(ctx);
        this.renderGrid(ctx);
        this.renderHandles(ctx);
        // Reset scale
        ctx.scale(1 / scaleX, 1 / scaleY);
      }
    }
  }, {
    key: 'renderOverlay',
    value: function renderOverlay(ctx) {
      var canvas = ctx.canvas;

      //
      //    x0    x1        x2      x3
      // y0 +------------------------+
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      // y1 +------+---------+-------+
      //    |\\\\\\|         |\\\\\\\|
      //    |\\\\\\|    0    |\\\\\\\|
      //    |\\\\\\|         |\\\\\\\|
      // y2 +------+---------+-------+
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      //    |\\\\\\\\\\\\\\\\\\\\\\\\|
      // y3 +------------------------+
      //

      var x0 = 0;
      var x1 = this.x;
      var x2 = this.x + this.width;
      var x3 = canvas.width;

      var y0 = 0;
      var y1 = this.y;
      var y2 = this.y + this.height;
      var y3 = canvas.height;

      ctx.beginPath();

      // Draw outer rectangle.
      // Numbers are +/-1 so that overlay edges don't get blurry.
      ctx.moveTo(x0 - 1, y0 - 1);
      ctx.lineTo(x3 + 1, y0 - 1);
      ctx.lineTo(x3 + 1, y3 + 1);
      ctx.lineTo(x0 - 1, y3 - 1);
      ctx.lineTo(x0 - 1, y0 - 1);
      ctx.closePath();

      // Draw inner rectangle.
      ctx.moveTo(x1, y1);
      ctx.lineTo(x1, y2);
      ctx.lineTo(x2, y2);
      ctx.lineTo(x2, y1);
      ctx.lineTo(x1, y1);

      ctx.closePath();
      ctx.fill();
      ctx.moveTo(0, 0);
    }
  }, {
    key: 'renderBorders',
    value: function renderBorders(ctx) {
      ctx.beginPath();
      ctx.moveTo(this.x, this.y); // upper left
      ctx.lineTo(this.x + this.width, this.y); // upper right
      ctx.lineTo(this.x + this.width, this.y + this.height); // down right
      ctx.lineTo(this.x, this.y + this.height); // down left
      ctx.lineTo(this.x, this.y); // upper left
      ctx.stroke();
    }
  }, {
    key: 'renderHandles',
    value: function renderHandles(ctx) {
      var _this3 = this;

      this.selectionHandles.forEach(function (handle, i) {
        var top = _this3.y;
        var left = _this3.x;
        var centerX = _this3.x + _this3.width / 2;
        var centerY = _this3.y + _this3.height / 2;
        var right = _this3.x + _this3.width;
        var bottom = _this3.y + _this3.height;
        var setCoords = [[left, top], [centerX, top], [right, top], [right, centerY], [right, bottom], [centerX, bottom], [left, bottom], [left, centerY]];

        handle.coords = setCoords[i];
        handle.render(ctx);
      });
    }
  }, {
    key: 'renderGrid',
    value: function renderGrid(ctx) {

      ctx.beginPath();
      ctx.moveTo(this.x + 1 / 3 * this.width, this.y);
      ctx.lineTo(this.x + 1 / 3 * this.width, this.y + this.height);
      ctx.stroke();
      ctx.beginPath();
      ctx.moveTo(this.x + 2 / 3 * this.width, this.y);
      ctx.lineTo(this.x + 2 / 3 * this.width, this.y + this.height);
      ctx.stroke();
      // Horizontal lines
      ctx.beginPath();
      ctx.moveTo(this.x, this.y + 1 / 3 * this.height);
      ctx.lineTo(this.x + this.width, this.y + 1 / 3 * this.height);
      ctx.stroke();
      ctx.beginPath();
      ctx.moveTo(this.x, this.y + 2 / 3 * this.height);
      ctx.lineTo(this.x + this.width, this.y + 2 / 3 * this.height);
      ctx.stroke();
    }
  }]);

  return CropBox;
}();